
#include <errno.h>

#include <unistd.h>
#include <qframe.h>
#include <klocale.h>
#include <kapp.h>
#include <kfm.h>
//nclude <libXicq.h>
#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include "kxicq.h"
#include "dialogs.h"
#include "users.h"

extern int logged_on;
extern mainWin *mainW;
extern KApplication *mainApp;
extern QList<MSG> userMsg;
extern struct kxicqConfig KxicqConfig;

/*
   int my_system (const char *command)
   {
   extern char **environ;
   int pid, status;

   if (command == 0)
   return 1;
   pid = fork();
   if (pid == -1)
   return -1;
   if (pid == 0)
   {
   char *argv[4];
   argv[0] = "sh";
   argv[1] = "-c";
   argv[2] = command;
   argv[3] = 0;
   execve("/bin/sh", argv, environ);
   exit(127);
   }
   do {
   if (waitpid(pid, &status, 0) == -1)
   {
   if (errno != EINTR)
   return -1;
   } else
   return status;
   } while(1);
   }
*/

Mail::Mail(unsigned long int uin,mainWin *parent, const char *name)
   : QDialog(parent, name,TRUE)
   {


      this->setFocusPolicy(QWidget::StrongFocus);
      setCaption("Message");
      to=uin;
      setFixedSize(330,250 );
      QFrame* dlgedit_Frame_1;
      dlgedit_Frame_1 = new QFrame( this, "Frame_1" );
      dlgedit_Frame_1->setGeometry( 10, 30, 310, 210 );
      dlgedit_Frame_1->setMinimumSize( 10, 10 );
      dlgedit_Frame_1->setMaximumSize( 32767, 32767 );
      dlgedit_Frame_1->setFrameStyle( 34 );


      dlgedit_MultiLineEdit_1 = new QMultiLineEdit( this, "MultiLineEdit_1" );
      dlgedit_MultiLineEdit_1->setGeometry( 20, 40, 290, 150 );
      dlgedit_MultiLineEdit_1->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_1->setMaximumSize( 32767, 32767 );
      //connect( dlgedit_MultiLineEdit_1, SIGNAL(textChanged()), SLOT(updateText()) );
      dlgedit_MultiLineEdit_1->insertLine( "" );
      dlgedit_MultiLineEdit_1->setReadOnly( FALSE );
      dlgedit_MultiLineEdit_1->setOverwriteMode( FALSE );
      dlgedit_MultiLineEdit_1->setFocus();

      QLabel* dlgedit_Label_5;
      dlgedit_Label_5 = new QLabel( this, "Label_5" );
      dlgedit_Label_5->setGeometry( 20, 8, 40, 20 );
      dlgedit_Label_5->setMinimumSize( 10, 10 );
      dlgedit_Label_5->setMaximumSize( 32767, 32767 );
      dlgedit_Label_5->setFrameStyle(50);
      dlgedit_Label_5->setText( "Nick:" );
      dlgedit_Label_5->setAlignment( 289 );
      dlgedit_Label_5->setMargin( -1 );

      QLabel* dlgedit_Label_6;
      dlgedit_Label_6 = new QLabel( this, "Label_6" );
      dlgedit_Label_6->setGeometry( 180, 8, 40, 20 );
      dlgedit_Label_6->setMinimumSize( 8, 10 );
      dlgedit_Label_6->setMaximumSize( 32767, 32767 );
      dlgedit_Label_6->setFrameStyle(50);
      dlgedit_Label_6->setText( "UIN:" );
      dlgedit_Label_6->setAlignment( 289 );
      dlgedit_Label_6->setMargin( -1 );

      QMultiLineEdit* dlgedit_Label_7;
      dlgedit_Label_7 = new QMultiLineEdit( this, "Label_7" );
      dlgedit_Label_7->setGeometry( 50, 8, 120, 20 );
      dlgedit_Label_7->setMinimumSize( 10, 10 );
      dlgedit_Label_7->setMaximumSize( 32767, 32767 );
      QString tmp;
      tmp.sprintf("%s", contact_uin2nick(uin));
      dlgedit_Label_7->insertLine(tmp.data() );
      dlgedit_Label_7->setReadOnly( TRUE );
      dlgedit_Label_7->setOverwriteMode( FALSE );
      //      dlgedit_Label_7->setAlignment( 289 );
      //      dlgedit_Label_7->setMargin( -1 );

      QMultiLineEdit* dlgedit_Label_8;
      dlgedit_Label_8 = new  QMultiLineEdit( this, "Label_8" );
      dlgedit_Label_8->setGeometry( 220, 8, 90, 20 );
      dlgedit_Label_8->setMinimumSize( 10, 10 );
      dlgedit_Label_8->setMaximumSize( 32767, 32767 );
      tmp.sprintf("%ld",uin);
      dlgedit_Label_8->insertLine( tmp.data() );
      dlgedit_Label_8->setReadOnly( TRUE );
      dlgedit_Label_8->setOverwriteMode( FALSE );

      //      dlgedit_Label_8->setAlignment( 289 );
      //      dlgedit_Label_8->setMargin( -1 );

      QPushButton* dlgedit_PushButton_2;
      dlgedit_PushButton_2 = new QPushButton( this, "PushButton_2" );
      dlgedit_PushButton_2->setGeometry( 20, 200, 100, 30 );
      dlgedit_PushButton_2->setMinimumSize( 10, 10 );
      dlgedit_PushButton_2->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_2, SIGNAL(clicked()), SLOT(ok_slot()) );
      dlgedit_PushButton_2->setText( "Send" );
      dlgedit_PushButton_2->setAutoRepeat( FALSE );
      dlgedit_PushButton_2->setAutoResize( FALSE );

      QPushButton *dlgedit_PushButton_3;
      dlgedit_PushButton_3 = new QPushButton( "Cancel",this, "PushButton_3" );
      dlgedit_PushButton_3->setGeometry( 210, 200, 100, 30 );
      //	dlgedit_PushButton_3->setMinimumSize( 10, 10 );
      //	dlgedit_PushButton_3->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_3, SIGNAL(clicked()), this, SLOT(cancel_slot()) );
      //	dlgedit_PushButton_3->setText( "Cancel" );
      //	dlgedit_PushButton_3->setAutoRepeat( FALSE );
      //	dlgedit_PushButton_3->setAutoResize( FALSE );


   }

void Mail::resizeEvent(QResizeEvent *)
{
}
void Mail::focusInEvent( QFocusEvent *)
{
}
void Mail::cancel_slot()
{
   reject();
}
void Mail::ok_slot()
{
   char *tmp;
   tmp=(char *)malloc(BUFSIZE);
   strcpy(tmp,dlgedit_MultiLineEdit_1->text().data());
   unix2dos(tmp);
   //   printf("To: %ld, [%s]\n",to,tmp);
   if (logged_on)
      send_message(to,tmp);
   else
      loggedon();
   free(tmp);
   accept();
}
//////////////////////////////////////////////////////////////////////////////////////////////


sendUrl::sendUrl(unsigned long int uin,mainWin *parent, const char *name)
   : QDialog(parent, name,TRUE)
   {


      this->setFocusPolicy(QWidget::StrongFocus);
      setCaption("Url");
      to=uin;
      setFixedSize(330,250 );
      QFrame* dlgedit_Frame_1;
      dlgedit_Frame_1 = new QFrame( this, "Frame_1" );
      dlgedit_Frame_1->setGeometry( 10, 30, 310, 210 );
      dlgedit_Frame_1->setMinimumSize( 10, 10 );
      dlgedit_Frame_1->setMaximumSize( 32767, 32767 );
      dlgedit_Frame_1->setFrameStyle( 34 );

      dlgedit_MultiLineEdit_2 = new QMultiLineEdit( this, "MultiLineEdit_2" );
      dlgedit_MultiLineEdit_2->setGeometry( 20, 40, 290, 20 );
      dlgedit_MultiLineEdit_2->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_2->setMaximumSize( 32767, 32767 );
      //connect( dlgedit_MultiLineEdit_1, SIGNAL(textChanged()), SLOT(updateText()) );
      dlgedit_MultiLineEdit_2->insertLine( "" );
      dlgedit_MultiLineEdit_2->setReadOnly( FALSE );
      dlgedit_MultiLineEdit_2->setOverwriteMode( FALSE );
      dlgedit_MultiLineEdit_2->setFocus();


      dlgedit_MultiLineEdit_1 = new QMultiLineEdit( this, "MultiLineEdit_1" );
      dlgedit_MultiLineEdit_1->setGeometry( 20, 65, 290, 135 );
      dlgedit_MultiLineEdit_1->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_1->setMaximumSize( 32767, 32767 );
      //connect( dlgedit_MultiLineEdit_1, SIGNAL(textChanged()), SLOT(updateText()) );
      dlgedit_MultiLineEdit_1->insertLine( "" );
      dlgedit_MultiLineEdit_1->setReadOnly( FALSE );
      dlgedit_MultiLineEdit_1->setOverwriteMode( FALSE );
      //      dlgedit_MultiLineEdit_1->setFocus();

      QLabel* dlgedit_Label_5;
      dlgedit_Label_5 = new QLabel( this, "Label_5" );
      dlgedit_Label_5->setGeometry( 20, 8, 40, 20 );
      dlgedit_Label_5->setMinimumSize( 10, 10 );
      dlgedit_Label_5->setMaximumSize( 32767, 32767 );
      dlgedit_Label_5->setFrameStyle(50);
      dlgedit_Label_5->setText( "Nick:" );
      dlgedit_Label_5->setAlignment( 289 );
      dlgedit_Label_5->setMargin( -1 );

      QLabel* dlgedit_Label_6;
      dlgedit_Label_6 = new QLabel( this, "Label_6" );
      dlgedit_Label_6->setGeometry( 180, 8, 40, 20 );
      dlgedit_Label_6->setMinimumSize( 8, 10 );
      dlgedit_Label_6->setMaximumSize( 32767, 32767 );
      dlgedit_Label_6->setFrameStyle(50);
      dlgedit_Label_6->setText( "UIN:" );
      dlgedit_Label_6->setAlignment( 289 );
      dlgedit_Label_6->setMargin( -1 );

      QMultiLineEdit* dlgedit_Label_7;
      dlgedit_Label_7 = new QMultiLineEdit( this, "Label_7" );
      dlgedit_Label_7->setGeometry( 50, 8, 120, 20 );
      dlgedit_Label_7->setMinimumSize( 10, 10 );
      dlgedit_Label_7->setMaximumSize( 32767, 32767 );
      QString tmp;
      tmp.sprintf("%s", contact_uin2nick(uin));
      dlgedit_Label_7->insertLine(tmp.data() );
      dlgedit_Label_7->setReadOnly( TRUE );
      dlgedit_Label_7->setOverwriteMode( FALSE );
      //      dlgedit_Label_7->setAlignment( 289 );
      //      dlgedit_Label_7->setMargin( -1 );

      QMultiLineEdit* dlgedit_Label_8;
      dlgedit_Label_8 = new  QMultiLineEdit( this, "Label_8" );
      dlgedit_Label_8->setGeometry( 220, 8, 90, 20 );
      dlgedit_Label_8->setMinimumSize( 10, 10 );
      dlgedit_Label_8->setMaximumSize( 32767, 32767 );
      tmp.sprintf("%ld",uin);
      dlgedit_Label_8->insertLine( tmp.data() );
      dlgedit_Label_8->setReadOnly( TRUE );
      dlgedit_Label_8->setOverwriteMode( FALSE );

      //      dlgedit_Label_8->setAlignment( 289 );
      //      dlgedit_Label_8->setMargin( -1 );

      QPushButton* dlgedit_PushButton_2;
      dlgedit_PushButton_2 = new QPushButton( this, "PushButton_2" );
      dlgedit_PushButton_2->setGeometry( 20, 200, 100, 30 );
      dlgedit_PushButton_2->setMinimumSize( 10, 10 );
      dlgedit_PushButton_2->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_2, SIGNAL(clicked()), SLOT(ok_slot()) );
      dlgedit_PushButton_2->setText( "Send" );
      dlgedit_PushButton_2->setAutoRepeat( FALSE );
      dlgedit_PushButton_2->setAutoResize( FALSE );

      QPushButton *dlgedit_PushButton_3;
      dlgedit_PushButton_3 = new QPushButton( "Cancel",this, "PushButton_3" );
      dlgedit_PushButton_3->setGeometry( 210, 200, 100, 30 );
      //	dlgedit_PushButton_3->setMinimumSize( 10, 10 );
      //	dlgedit_PushButton_3->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_3, SIGNAL(clicked()), this, SLOT(cancel_slot()) );
      //	dlgedit_PushButton_3->setText( "Cancel" );
      //	dlgedit_PushButton_3->setAutoRepeat( FALSE );
      //	dlgedit_PushButton_3->setAutoResize( FALSE );


   }

void sendUrl::resizeEvent(QResizeEvent *)
{
}
void sendUrl::focusInEvent( QFocusEvent *)
{
}
void sendUrl::cancel_slot()
{
   reject();
}
void sendUrl::ok_slot()
{
   char *tmp;
   tmp=(char *)malloc(BUFSIZE);
   strcpy(tmp,dlgedit_MultiLineEdit_1->text().data());
   unix2dos(tmp);

   //   printf("URL To: %ld, [%s,%s]\n"
   //      ,to,dlgedit_MultiLineEdit_2->text().data(), tmp);
   if (logged_on)
      send_url(to,dlgedit_MultiLineEdit_2->text().data(),tmp);
   else
      loggedon();
   free(tmp);
   accept();
}
//////////////////////////////////////////////////////////////////////////////////////////////

readMail::readMail(mainWin *parent, const char *name)
   : QDialog(parent, name,TRUE)
   {


      this->setFocusPolicy(QWidget::StrongFocus);

      //      to=uin;
      setCaption("Message");
      QButtonGroup* dlgedit_ButtonGroup_1;
      dlgedit_ButtonGroup_1 = new QButtonGroup( this, "ButtonGroup_1" );
      dlgedit_ButtonGroup_1->setGeometry( 10, 10, 380, 240 );
      dlgedit_ButtonGroup_1->setMinimumSize( 10, 10 );
      dlgedit_ButtonGroup_1->setMaximumSize( 32767, 32767 );
      dlgedit_ButtonGroup_1->setFrameStyle( 49 );
      dlgedit_ButtonGroup_1->setTitle( "Message" );
      dlgedit_ButtonGroup_1->setAlignment( 1 );


      dlgedit_MultiLineEdit_2 = new QMultiLineEdit( this, "MultiLineEdit_2" );
      dlgedit_MultiLineEdit_2->setGeometry( 20, 90, 360, 150 );
      dlgedit_MultiLineEdit_2->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_2->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_2->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_2->setOverwriteMode( FALSE );
      dlgedit_MultiLineEdit_3 = new QMultiLineEdit( this, "MultiLineEdit_3" );
      dlgedit_MultiLineEdit_3->setGeometry( 70, 30, 130, 20 );
      dlgedit_MultiLineEdit_3->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_3->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_3->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_3->setOverwriteMode( FALSE );

      dlgedit_MultiLineEdit_4 = new QMultiLineEdit( this, "MultiLineEdit_4" );
      dlgedit_MultiLineEdit_4->setGeometry( 70, 60, 130, 20 );
      dlgedit_MultiLineEdit_4->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_4->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_4->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_4->setOverwriteMode( FALSE );

      QLabel* dlgedit_Label_9;
      dlgedit_Label_9 = new QLabel( this, "Label_9" );
      dlgedit_Label_9->setGeometry( 20, 30, 50, 20 );
      dlgedit_Label_9->setMinimumSize( 10, 10 );
      dlgedit_Label_9->setMaximumSize( 32767, 32767 );
      dlgedit_Label_9->setFrameStyle(50);
      dlgedit_Label_9->setText( "Nick:" );
      dlgedit_Label_9->setAlignment( 289 );
      dlgedit_Label_9->setMargin( -1 );

      QLabel* dlgedit_Label_10;
      dlgedit_Label_10 = new QLabel( this, "Label_10" );
      dlgedit_Label_10->setGeometry( 20, 60, 50, 20 );
      dlgedit_Label_10->setMinimumSize( 10, 10 );
      dlgedit_Label_10->setMaximumSize( 32767, 32767 );
      dlgedit_Label_10->setFrameStyle(50);
      dlgedit_Label_10->setText( "UIN :" );
      dlgedit_Label_10->setAlignment( 289 );
      dlgedit_Label_10->setMargin( -1 );

      QLabel* dlgedit_Label_11;
      dlgedit_Label_11 = new QLabel( this, "Label_11" );
      dlgedit_Label_11->setGeometry( 230, 30, 50, 20 );
      dlgedit_Label_11->setMinimumSize( 10, 10 );
      dlgedit_Label_11->setMaximumSize( 32767, 32767 );
      dlgedit_Label_11->setFrameStyle(50);
      dlgedit_Label_11->setText( "Date:" );
      dlgedit_Label_11->setAlignment( 289 );
      dlgedit_Label_11->setMargin( -1 );

      QLabel* dlgedit_Label_12;
      dlgedit_Label_12 = new QLabel( this, "Label_12" );
      dlgedit_Label_12->setGeometry( 230, 60, 50, 20 );
      dlgedit_Label_12->setMinimumSize( 10, 10 );
      dlgedit_Label_12->setMaximumSize( 32767, 32767 );
      dlgedit_Label_12->setFrameStyle(50);
      dlgedit_Label_12->setText( "Time:" );
      dlgedit_Label_12->setAlignment( 289 );
      dlgedit_Label_12->setMargin( -1 );


      dlgedit_MultiLineEdit_5 = new QMultiLineEdit( this, "MultiLineEdit_5" );
      dlgedit_MultiLineEdit_5->setGeometry( 280, 30, 100, 20 );
      dlgedit_MultiLineEdit_5->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_5->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_5->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_5->setOverwriteMode( FALSE );
      dlgedit_MultiLineEdit_6 = new QMultiLineEdit( this, "MultiLineEdit_6" );
      dlgedit_MultiLineEdit_6->setGeometry( 280, 60, 100, 20 );
      dlgedit_MultiLineEdit_6->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_6->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_6->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_6->setOverwriteMode( FALSE );

      QPushButton* dlgedit_PushButton_4;
      dlgedit_PushButton_4 = new QPushButton( this, "PushButton_4" );
      dlgedit_PushButton_4->setGeometry( 10, 260, 75, 30 );
      dlgedit_PushButton_4->setMinimumSize( 10, 10 );
      dlgedit_PushButton_4->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_4, SIGNAL(pressed()), SLOT(ok_slot()) );
      dlgedit_PushButton_4->setText( "Ok" );
      dlgedit_PushButton_4->setAutoRepeat( FALSE );
      dlgedit_PushButton_4->setAutoResize( FALSE );

      QPushButton* dlgedit_PushButton_5;
      dlgedit_PushButton_5 = new QPushButton( this, "PushButton_5" );
      dlgedit_PushButton_5->setGeometry( 180, 260, 75, 30 );
      dlgedit_PushButton_5->setMinimumSize( 10, 10 );
      dlgedit_PushButton_5->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_5, SIGNAL(pressed()), SLOT(cancel_slot()) );
      dlgedit_PushButton_5->setText( "Whois" );
      dlgedit_PushButton_5->setAutoRepeat( FALSE );
      dlgedit_PushButton_5->setAutoResize( FALSE );

      QPushButton* dlgedit_PushButton_6;
      dlgedit_PushButton_6 = new QPushButton( this, "PushButton_6" );
      dlgedit_PushButton_6->setGeometry( 95, 260, 75, 30 );
      dlgedit_PushButton_6->setMinimumSize( 10, 10 );
      dlgedit_PushButton_6->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_6, SIGNAL(pressed()), SLOT(reply_slot()) );
      dlgedit_PushButton_6->setText( "Reply" );
      dlgedit_PushButton_6->setAutoRepeat( FALSE );
      dlgedit_PushButton_6->setAutoResize( FALSE );

      QPushButton* dlgedit_PushButton_7;
      dlgedit_PushButton_7 = new QPushButton( this, "PushButton_7" );
      dlgedit_PushButton_7->setGeometry( 340, 260, 50, 14 );
      dlgedit_PushButton_7->setMinimumSize( 10, 10 );
      dlgedit_PushButton_7->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_7, SIGNAL(pressed()), SLOT(next_slot()) );
      dlgedit_PushButton_7->setText( "Next" );
      dlgedit_PushButton_7->setAutoRepeat( FALSE );
      dlgedit_PushButton_7->setAutoResize( FALSE );


      QPushButton* dlgedit_PushButton_8;
      dlgedit_PushButton_8 = new QPushButton( this, "PushButton_8" );
      dlgedit_PushButton_8->setGeometry( 340, 276, 50, 14 );
      dlgedit_PushButton_8->setMinimumSize( 10, 10 );
      dlgedit_PushButton_8->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_8, SIGNAL(pressed()), SLOT(prev_slot()) );
      dlgedit_PushButton_8->setText( "Prev" );
      dlgedit_PushButton_8->setAutoRepeat( FALSE );
      dlgedit_PushButton_8->setAutoResize( FALSE );


      setFixedSize(400,300 );


   }

void readMail::resizeEvent(QResizeEvent *)
{

}


void readMail::focusInEvent( QFocusEvent *)
{


}
void readMail::prev_slot()
{

}
void readMail::next_slot()
{

}
void readMail::cancel_slot()
{
   if (logged_on) send_uinSearch(atol(dlgedit_MultiLineEdit_4->text())); else loggedon();
   accept();
}

void readMail::ok_slot()
{

   //   printf("To: %ld, [%s]\n",to,dlgedit_MultiLineEdit_1->text().data());
   //   if (logged_on)
   //      send_message(to,dlgedit_MultiLineEdit_1->text().data());
   //   else
   //      loggedon();
   accept();
}
void readMail::reply_slot()
{

   //   printf("To: %ld, [%s]\n",to,dlgedit_MultiLineEdit_1->text().data());
   //   if (logged_on)
   //      send_message(to,dlgedit_MultiLineEdit_1->text().data());
   //   else
   //      loggedon();
   hide();
   Mail *myMsgWin;
   myMsgWin=new Mail(atol(dlgedit_MultiLineEdit_4->text()),mainW,"msgedit");

   if (!myMsgWin->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete myMsgWin;
   accept();
}

void readMail::setMessage(char *msg)
{
   dlgedit_MultiLineEdit_2->insertLine(msg);
}
void readMail::setUin(unsigned long int uin)
{
   dlgedit_MultiLineEdit_3->insertLine(contact_uin2nick(uin));
   QString tmp;
   tmp.sprintf("%ld",uin);
   dlgedit_MultiLineEdit_4->insertLine(tmp.data());
}
void readMail::setDate(int m, int d, int y)
{
   QString tmp;
   tmp.sprintf("%02d/%02d/%04d",d,m,y);
   dlgedit_MultiLineEdit_5->insertLine(tmp.data());
}
void readMail::setTime(int h, int m)
{
   QString tmp;
   tmp.sprintf("%02d:%02d",h,m);
   dlgedit_MultiLineEdit_6->insertLine(tmp.data());
}


/////////////////////////



readUrl::readUrl(mainWin *parent, const char *name)
   : QDialog(parent, name,TRUE)
   {


      this->setFocusPolicy(QWidget::StrongFocus);

      //      to=uin;
      setCaption("Url");
      QButtonGroup* dlgedit_ButtonGroup_1;
      dlgedit_ButtonGroup_1 = new QButtonGroup( this, "ButtonGroup_1" );
      dlgedit_ButtonGroup_1->setGeometry( 10, 10, 380, 240 );
      dlgedit_ButtonGroup_1->setMinimumSize( 10, 10 );
      dlgedit_ButtonGroup_1->setMaximumSize( 32767, 32767 );
      dlgedit_ButtonGroup_1->setFrameStyle( 49 );
      dlgedit_ButtonGroup_1->setTitle( "Message" );
      dlgedit_ButtonGroup_1->setAlignment( 1 );


      dlgedit_MultiLineEdit_2 = new QMultiLineEdit( this, "MultiLineEdit_2" );
      dlgedit_MultiLineEdit_2->setGeometry( 20, 115, 360, 135 );
      dlgedit_MultiLineEdit_2->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_2->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_2->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_2->setOverwriteMode( FALSE );

      dlgedit_MultiLineEdit_7 = new QMultiLineEdit( this, "MultiLineEdit_7" );
      dlgedit_MultiLineEdit_7->setGeometry( 20, 90, 360, 20 );
      dlgedit_MultiLineEdit_7->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_7->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_7->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_7->setOverwriteMode( FALSE );


      dlgedit_MultiLineEdit_3 = new QMultiLineEdit( this, "MultiLineEdit_3" );
      dlgedit_MultiLineEdit_3->setGeometry( 70, 30, 130, 20 );
      dlgedit_MultiLineEdit_3->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_3->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_3->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_3->setOverwriteMode( FALSE );

      dlgedit_MultiLineEdit_4 = new QMultiLineEdit( this, "MultiLineEdit_4" );
      dlgedit_MultiLineEdit_4->setGeometry( 70, 60, 130, 20 );
      dlgedit_MultiLineEdit_4->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_4->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_4->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_4->setOverwriteMode( FALSE );

      QLabel* dlgedit_Label_9;
      dlgedit_Label_9 = new QLabel( this, "Label_9" );
      dlgedit_Label_9->setGeometry( 20, 30, 50, 20 );
      dlgedit_Label_9->setMinimumSize( 10, 10 );
      dlgedit_Label_9->setMaximumSize( 32767, 32767 );
      dlgedit_Label_9->setFrameStyle(50);
      dlgedit_Label_9->setText( "Nick:" );
      dlgedit_Label_9->setAlignment( 289 );
      dlgedit_Label_9->setMargin( -1 );

      QLabel* dlgedit_Label_10;
      dlgedit_Label_10 = new QLabel( this, "Label_10" );
      dlgedit_Label_10->setGeometry( 20, 60, 50, 20 );
      dlgedit_Label_10->setMinimumSize( 10, 10 );
      dlgedit_Label_10->setMaximumSize( 32767, 32767 );
      dlgedit_Label_10->setFrameStyle(50);
      dlgedit_Label_10->setText( "UIN :" );
      dlgedit_Label_10->setAlignment( 289 );
      dlgedit_Label_10->setMargin( -1 );

      QLabel* dlgedit_Label_11;
      dlgedit_Label_11 = new QLabel( this, "Label_11" );
      dlgedit_Label_11->setGeometry( 230, 30, 50, 20 );
      dlgedit_Label_11->setMinimumSize( 10, 10 );
      dlgedit_Label_11->setMaximumSize( 32767, 32767 );
      dlgedit_Label_11->setFrameStyle(50);
      dlgedit_Label_11->setText( "Date:" );
      dlgedit_Label_11->setAlignment( 289 );
      dlgedit_Label_11->setMargin( -1 );

      QLabel* dlgedit_Label_12;
      dlgedit_Label_12 = new QLabel( this, "Label_12" );
      dlgedit_Label_12->setGeometry( 230, 60, 50, 20 );
      dlgedit_Label_12->setMinimumSize( 10, 10 );
      dlgedit_Label_12->setMaximumSize( 32767, 32767 );
      dlgedit_Label_12->setFrameStyle(50);
      dlgedit_Label_12->setText( "Time:" );
      dlgedit_Label_12->setAlignment( 289 );
      dlgedit_Label_12->setMargin( -1 );


      dlgedit_MultiLineEdit_5 = new QMultiLineEdit( this, "MultiLineEdit_5" );
      dlgedit_MultiLineEdit_5->setGeometry( 280, 30, 100, 20 );
      dlgedit_MultiLineEdit_5->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_5->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_5->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_5->setOverwriteMode( FALSE );
      dlgedit_MultiLineEdit_6 = new QMultiLineEdit( this, "MultiLineEdit_6" );
      dlgedit_MultiLineEdit_6->setGeometry( 280, 60, 100, 20 );
      dlgedit_MultiLineEdit_6->setMinimumSize( 10, 10 );
      dlgedit_MultiLineEdit_6->setMaximumSize( 32767, 32767 );
      dlgedit_MultiLineEdit_6->setReadOnly( TRUE );
      dlgedit_MultiLineEdit_6->setOverwriteMode( FALSE );

      QPushButton* dlgedit_PushButton_4;
      dlgedit_PushButton_4 = new QPushButton( this, "PushButton_4" );
      dlgedit_PushButton_4->setGeometry( 10, 260, 100, 30 );
      dlgedit_PushButton_4->setMinimumSize( 10, 10 );
      dlgedit_PushButton_4->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_4, SIGNAL(pressed()), SLOT(ok_slot()) );
      dlgedit_PushButton_4->setText( "Ok" );
      dlgedit_PushButton_4->setAutoRepeat( FALSE );
      dlgedit_PushButton_4->setAutoResize( FALSE );

      QPushButton* dlgedit_PushButton_5;
      dlgedit_PushButton_5 = new QPushButton( this, "PushButton_5" );
      dlgedit_PushButton_5->setGeometry( 290, 260, 100, 30 );
      dlgedit_PushButton_5->setMinimumSize( 10, 10 );
      dlgedit_PushButton_5->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_5, SIGNAL(pressed()), SLOT(cancel_slot()) );
      dlgedit_PushButton_5->setText( "Whois" );
      dlgedit_PushButton_5->setAutoRepeat( FALSE );
      dlgedit_PushButton_5->setAutoResize( FALSE );

      QPushButton* dlgedit_PushButton_6;
      dlgedit_PushButton_6 = new QPushButton( this, "PushButton_6" );
      dlgedit_PushButton_6->setGeometry( 150, 260, 100, 30 );
      dlgedit_PushButton_6->setMinimumSize( 10, 10 );
      dlgedit_PushButton_6->setMaximumSize( 32767, 32767 );
      connect( dlgedit_PushButton_6, SIGNAL(pressed()), SLOT(reply_slot()) );
      dlgedit_PushButton_6->setText( "Reply" );
      dlgedit_PushButton_6->setAutoRepeat( FALSE );
      dlgedit_PushButton_6->setAutoResize( FALSE );


      setFixedSize(400,300 );


   }

void readUrl::resizeEvent(QResizeEvent *)
{

}


void readUrl::focusInEvent( QFocusEvent *)
{


}

void readUrl::cancel_slot()
{
   if (logged_on) send_uinSearch(atol(dlgedit_MultiLineEdit_4->text())); else loggedon();
   accept();
}

void readUrl::ok_slot()
{

   accept();
}
void readUrl::reply_slot()
{

   hide();
   Mail *myMsgWin;
   myMsgWin=new Mail(atol(dlgedit_MultiLineEdit_4->text()),mainW,"msgedit");

   if (!myMsgWin->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete myMsgWin;
   accept();
}

void readUrl::setMessage(char *msg)
{
   dlgedit_MultiLineEdit_2->insertLine(msg);
}
void readUrl::setUrl(char *url)
{
   dlgedit_MultiLineEdit_7->insertLine(url);
}
void readUrl::setUin(unsigned long int uin)
{
   dlgedit_MultiLineEdit_3->insertLine(contact_uin2nick(uin));
   QString tmp;
   tmp.sprintf("%ld",uin);
   dlgedit_MultiLineEdit_4->insertLine(tmp.data());
}
void readUrl::setDate(int m, int d, int y)
{
   QString tmp;
   tmp.sprintf("%02d/%02d/%04d",d,m,y);
   dlgedit_MultiLineEdit_5->insertLine(tmp.data());
}
void readUrl::setTime(int h, int m)
{
   QString tmp;
   tmp.sprintf("%02d:%02d",h,m);
   dlgedit_MultiLineEdit_6->insertLine(tmp.data());
}


////////// READ MSG/URL etc. CLASS /////////////////

Read::Read(UIN u, mainWin *parent, const char *name)
   : QDialog(parent,name,TRUE)
   {
      uin=u;
      setFixedSize(400,300);
      msgView=new QFrame(this);
      urlView=new QFrame(this);
      addView=new QFrame(this);
      buttonView=new QFrame(this);
      msgView->setGeometry(0,0,400,260);

      msgGroup=new QButtonGroup(msgView);
      msgGroup->setGeometry(5,5,390,255);
      msgGroup->setTitle("Message :");
      QLabel *uinL=new QLabel(msgView);
      uinL->setGeometry(15,25,40,20);
      uinL->setText("Uin:");
      uinL->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      msgViewUin=new QLabel(msgView);
      msgViewUin->setGeometry(57,25,125,20);
      msgViewUin->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *nickL=new QLabel(msgView);
      nickL->setGeometry(15,47,40,20);
      nickL->setText("Nick:");
      nickL->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      msgViewNick=new QLabel(msgView);
      msgViewNick->setGeometry(57,47,125,20);
      msgViewNick->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *dateL=new QLabel(msgView);
      dateL->setGeometry(195,25,40,20);
      dateL->setText("Date:");
      dateL->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      msgViewDate=new QLabel(msgView);
      msgViewDate->setGeometry(237,25,75,20);
      msgViewDate->setFrameStyle(QFrame::Raised | QFrame::Panel);
      QLabel *timeL=new QLabel(msgView);
      timeL->setGeometry(195,47,40,20);
      timeL->setText("Time:");
      timeL->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      msgViewTime=new QLabel(msgView);
      msgViewTime->setGeometry(237,47,75,20);
      msgViewTime->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *readL=new QLabel(msgView);
      readL->setGeometry(322,25,40,20);
      readL->setText("Read:");
      readL->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      msgViewRead=new QCheckBox(msgView);
      msgViewRead->setGeometry(367,25,20,20);
      msgViewRead->setEnabled(FALSE);

      msgViewMsg=new QMultiLineEdit(msgView);
      msgViewMsg->setGeometry(15,73,370,180);
      msgViewMsg->setReadOnly(TRUE);
      /////////////////////////////////////////////////////////////

      urlView->setGeometry(0,0,400,260);
      urlGroup=new QButtonGroup(urlView);
      urlGroup->setGeometry(5,5,390,255);
      urlGroup->setTitle("URL :");
      QLabel *uinLu=new QLabel(urlView);
      uinLu->setGeometry(15,25,40,20);
      uinLu->setText("Uin:");
      uinLu->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewUin=new QLabel(urlView);
      urlViewUin->setGeometry(57,25,125,20);
      urlViewUin->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *nickLu=new QLabel(urlView);
      nickLu->setGeometry(15,47,40,20);
      nickLu->setText("Nick:");
      nickLu->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewNick=new QLabel(urlView);
      urlViewNick->setGeometry(57,47,125,20);
      urlViewNick->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *dateLu=new QLabel(urlView);
      dateLu->setGeometry(195,25,40,20);
      dateLu->setText("Date:");
      dateLu->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewDate=new QLabel(urlView);
      urlViewDate->setGeometry(237,25,75,20);
      urlViewDate->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *timeLu=new QLabel(urlView);
      timeLu->setGeometry(195,47,40,20);
      timeLu->setText("Time:");
      timeLu->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewTime=new QLabel(urlView);
      urlViewTime->setGeometry(237,47,75,20);
      urlViewTime->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *readLu=new QLabel(urlView);
      readLu->setGeometry(322,25,40,20);
      readLu->setText("Read:");
      readLu->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewRead=new QCheckBox(urlView);
      urlViewRead->setGeometry(367,25,20,20);
      urlViewRead->setEnabled(FALSE);


      urlViewMsg=new QMultiLineEdit(urlView);
      urlViewMsg->setGeometry(15,97,370,156);
      urlViewMsg->setReadOnly(TRUE);

      urlViewUrl=new KURLLabel(urlView);
      urlViewUrl->setGeometry(15,73,370,20);
      urlViewUrl->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      urlViewUrl->setTipText("Open this URL");
      urlViewUrl->setUseTips(TRUE);
      connect(urlViewUrl,SIGNAL(leftClickedURL(const char* )),this, SLOT(processURL(const char*)));



      /////////////////////////////////////////////////////////////
      addView->setGeometry(0,0,400,260);

      addGroup=new QButtonGroup(addView);
      addGroup->setGeometry(5,5,390,255);
      addGroup->setTitle("Uin :");
      QLabel *uinLa=new QLabel(addView);
      uinLa->setGeometry(15,25,40,20);
      uinLa->setText("Uin:");
      uinLa->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      addViewUin=new QLabel(addView);
      addViewUin->setGeometry(57,25,125,20);
      addViewUin->setFrameStyle(QFrame::Raised | QFrame::Panel);
      QLabel *nickLa=new QLabel(addView);
      nickLa->setGeometry(15,47,40,20);
      nickLa->setText("Nick:");
      nickLa->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      addViewNick=new QLabel(addView);
      addViewNick->setGeometry(57,47,125,20);
      addViewNick->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *dateLa=new QLabel(addView);
      dateLa->setGeometry(195,25,40,20);
      dateLa->setText("Date:");
      dateLa->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      addViewDate=new QLabel(addView);
      addViewDate->setGeometry(237,25,75,20);
      addViewDate->setFrameStyle(QFrame::Raised | QFrame::Panel);
      QLabel *timeLa=new QLabel(addView);
      timeLa->setGeometry(195,47,40,20);
      timeLa->setText("Time:");
      timeLa->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      addViewTime=new QLabel(addView);
      addViewTime->setGeometry(237,47,75,20);
      addViewTime->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *readLa=new QLabel(addView);
      readLa->setGeometry(322,25,40,20);
      readLa->setText("Read:");
      readLa->setFrameStyle(QFrame::Sunken | QFrame::Panel);
      addViewRead=new QCheckBox(addView);
      addViewRead->setGeometry(367,25,20,20);
      addViewRead->setEnabled(FALSE);


      QButtonGroup *addBg=new QButtonGroup(addView);
      addBg->setGeometry(15,73,370,180);
      addBg->setTitle("You are added by");



      QLabel *Fa=new QLabel(addView);
      Fa->setGeometry(25, 93,63,20);
      Fa->setText("Nick:");
      Fa->setFrameStyle(QFrame::Sunken | QFrame::Panel);

      addViewrNick=new QLabel(addView);
      addViewrNick->setGeometry(95,93,150,20);
      addViewrNick->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *La=new QLabel(addView);
      La->setGeometry(25, 118,63,20);
      La->setText("Firstname:");
      La->setFrameStyle(QFrame::Sunken | QFrame::Panel);

      addViewFirst=new QLabel(addView);
      addViewFirst->setGeometry(95,118,150,20);
      addViewFirst->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *Lna=new QLabel(addView);
      Lna->setGeometry(25, 143,63,20);
      Lna->setText("Lastname:");
      Lna->setFrameStyle(QFrame::Sunken | QFrame::Panel);

      addViewLast=new QLabel(addView);
      addViewLast->setGeometry(95,143,150,20);
      addViewLast->setFrameStyle(QFrame::Raised | QFrame::Panel);

      QLabel *Ea=new QLabel(addView);
      Ea->setGeometry(25, 168,63,20);
      Ea->setText("E-Mail:");
      Ea->setFrameStyle(QFrame::Sunken | QFrame::Panel);

      addViewEmail=new QLabel(addView);
      addViewEmail->setGeometry(95,168,150,20);
      addViewEmail->setFrameStyle(QFrame::Raised | QFrame::Panel);


      /////////////////////////////////////////////////////
      buttonView->setGeometry(0,261,400,39);

      okButton=new QPushButton(buttonView);
      okButton->setGeometry(5,5,75,30);
      okButton->setText("Ok");
      connect( okButton, SIGNAL(clicked()), SLOT(ok_slot()) );

      whoisButton=new QPushButton(buttonView);
      whoisButton->setGeometry(85,5,75,30);
      whoisButton->setText("Whois");
      connect( whoisButton, SIGNAL(clicked()), SLOT(whois_slot()) );

      replyButton=new QPushButton(buttonView);
      replyButton->setGeometry(165,5,75,30);
      replyButton->setText("Reply");
      connect( replyButton, SIGNAL(clicked()), SLOT(reply_slot()) );

      nextButton=new QPushButton(buttonView);
      nextButton->setGeometry(345,5,50,15);
      nextButton->setText("Next");
      connect( nextButton, SIGNAL(clicked()), SLOT(next_slot()) );
      prevButton=new QPushButton(buttonView);
      prevButton->setGeometry(345,21,50,15);
      prevButton->setText("Prev");
      connect( prevButton, SIGNAL(clicked()), SLOT(prev_slot()) );


      urlView->hide();
      addView->hide();
      msgView->show();
      found=0;
      wait=0;
      view=0;
      lastMsg();
      if (found==0) reject();
      else
      {
	 showMsg();
	 msgView->show();
	 buttonView->show();
	 //	 show();
      }

   }
Read::~Read()
{
}

void Read::processURL(const char *url)
{
   printf ("%s\n",url);
   if (KxicqConfig.typeBrowser==0)
   {
      QString tmp;
      tmp.sprintf("kfmclient openURL \"%s\"",url);
      system(tmp.data());
      return;
   }
   if (strlen(KxicqConfig.browser)>0)
   {
      char *tmp;
      tmp=(char *)malloc(1024);
      sprintf(tmp,"%s %s &",KxicqConfig.browser, url);
      system(tmp);
      free(tmp);
   }

}

void Read::showMsg()
{
   MESSAGE msg;
   URL url;
   ADDED add;
   QString tmp(BUFSIZE+1);
   QString tmp1(BUFSIZE+1);
   QString tmp2(BUFSIZE+1);
   QString tmp3(BUFSIZE+1);
   QString tmp4(BUFSIZE+1);
   QString tmp5(BUFSIZE+1);
   QString tmp6(BUFSIZE+1);

   //   printf("VIEW[%d][%ld]\n",pntMsg->getType(),pntMsg->getUin());
   switch(pntMsg->getType())
   {
      case TYPE_MSG:
	 //	 printf("MSG VIEW\n");
	 tmp1.sprintf("%ld",pntMsg->getUin());
	 msgViewUin->setText(tmp1.data());
	 msgViewNick->setText(contact_uin2nick(pntMsg->getUin()));
	 msg=pntMsg->getMsg();
	 tmp2.sprintf("%02d/%02d/%d",msg.time.month, msg.time.day, msg.time.year);
	 msgViewDate->setText(tmp2.data());
	 tmp3.sprintf("%2d:%02d",msg.time.hour, msg.time.min);
	 msgViewTime->setText(tmp3.data());
	 msgViewRead->setChecked(pntMsg->getRead()==0 ? FALSE : TRUE);
	 msgViewMsg->clear();

	 tmp4.sprintf("%s",pntMsg->getrMsg());
	 msgViewMsg->insertLine(tmp4.data());
	 //msgView->repaint();
	 if (view!=TYPE_MSG)
	 {
	    urlView->hide();
	    msgView->show();
	    addView->hide();
	    view=TYPE_MSG;
	 }
	 break;

      case TYPE_URL:
	 //	 printf("URL VIEW\n");

	 tmp1.sprintf("%ld",pntMsg->getUin());
	 urlViewUin->setText(tmp1.data());

	 urlViewNick->setText(contact_uin2nick(pntMsg->getUin()));
	 url=pntMsg->getUrl();
	 tmp2.sprintf("%02d/%02d/%d",url.time.month, url.time.day, url.time.year);
	 urlViewDate->setText(tmp2.data());
	 tmp3.sprintf("%2d:%02d",url.time.hour, url.time.min);
	 urlViewTime->setText(tmp3.data());
	 urlViewRead->setChecked(pntMsg->getRead()==0 ? FALSE : TRUE);
	 tmp4.sprintf("%s",pntMsg->getrUrl());
	 urlViewUrl->setText(tmp4.data());
	 tmp5.sprintf("%s",pntMsg->getrUrl());
	 urlViewUrl->setURL(tmp5.data());

	 urlViewMsg->clear();
	 tmp.sprintf("%s",pntMsg->getrMsg());
	 urlViewMsg->insertLine(tmp.data());
	 if (view!=TYPE_URL)
	 {
	    msgView->hide();
	    urlView->show();
	    addView->hide();
	    view=TYPE_URL;
	 }
	 break;
      case TYPE_ADDED:
	 //       printf("ADD VIEW\n");
	 tmp.sprintf("%ld",pntMsg->getUin());
	 addViewUin->setText(tmp.data());
	 addViewNick->setText(contact_uin2nick(pntMsg->getUin()));
	 add=pntMsg->getAdded();
	 tmp1.sprintf("%02d/%02d/%d",add.time.month, add.time.day, add.time.year);
	 addViewDate->setText(tmp1.data());
	 tmp2.sprintf("%2d:%02d",add.time.hour, add.time.min);
	 addViewTime->setText(tmp2.data());
	 addViewRead->setChecked(pntMsg->getRead()==0 ? FALSE : TRUE);

	 tmp3.sprintf("%s",pntMsg->getFirstName());
	 addViewFirst->setText(tmp3.data());
	 tmp4.sprintf("%s",pntMsg->getLastName());
	 addViewLast->setText(tmp4.data());
	 tmp5.sprintf("%s",pntMsg->getrNick());
	 addViewrNick->setText(tmp5.data());
	 tmp6.sprintf("%s",pntMsg->getEmail());
	 addViewEmail->setText(tmp6.data());

	 msgView->hide();
	 urlView->hide();
	 addView->show();
	 view=TYPE_ADDED;
	 break;
   }

}

void Read::firstMsg()
{
   if (wait==0)
   {
      wait=1;
      if (uin!=TYPE_SERVER)
      {
	 for (pntMsg=userMsg.first(); pntMsg!=0; pntMsg=userMsg.next())
	 {
	    if (pntMsg->getUin()==uin)
	    {
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }
      found=0;
      wait=0;
   }
}

void Read::lastMsg()
{
   if (wait==0)
   {
      wait=1;
      if (uin!=TYPE_SERVER)
      {
	 for (pntMsg=userMsg.last(); pntMsg!=0; pntMsg=userMsg.prev())
	 {
	    if (pntMsg->getUin()==uin)
	    {
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }
      else
      {
	 for (pntMsg=userMsg.last(); pntMsg!=0; pntMsg=userMsg.prev())
	 {
	    if (pntMsg->getUin()==(UIN)atol(contact_uin2nick(pntMsg->getUin())))
	    {
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }

      found=0;
      wait=0;
   }
}

void Read::prevMsg()
{
   if (wait==0)
   {
      userMsg.find(pntMsg);
      wait=1;
      MSG *old;
      old=pntMsg;
      if (uin!=TYPE_SERVER)
      {
	 //	 printf("FF[%ld]\n", pntMsg->getUin());
	 while (!(userMsg.current()==userMsg.getFirst()))
	 {
	    //    printf("PREV\n");
	    pntMsg=userMsg.prev();
	    //    printf("SetPREV[%ld]\n",pntMsg->getUin());
	    if (pntMsg->getUin()==uin)
	    {
	       old->setRead(1);
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }
      else
      {
	 while (!(userMsg.current()==userMsg.getFirst()))
	 {
	    pntMsg=userMsg.prev();
	    if (pntMsg->getUin()==(UIN)atol(contact_uin2nick(pntMsg->getUin())))
	    {
	       old->setRead(1);
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }


      pntMsg=old;
      found=0;
      wait=0;
   }
}

void Read::nextMsg()
{
   if (wait==0)
   {
      userMsg.find(pntMsg);
      wait=1;
      MSG *old;
      old=pntMsg;
      if (uin!=TYPE_SERVER)
      {
	 while(!(userMsg.current()==userMsg.getLast()))
	 {
	    pntMsg=userMsg.next();
	    if (pntMsg->getUin()==uin)
	    {
	       old->setRead(1);
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }
      else
      {
	 while(!(userMsg.current()==userMsg.getLast()))
	 {
	    pntMsg=userMsg.next();
	    if (pntMsg->getUin()==(UIN)atol(contact_uin2nick(pntMsg->getUin())))
	    {
	       old->setRead(1);
	       wait=0;
	       found=1;
	       return;
	    }
	 }
      }
      pntMsg=old;
      found=0;
      wait=0;
   }
}



////////// SLOTS ///////////////////////////////////

void Read::ok_slot()
{
   pntMsg->setRead(1);
   accept();
}
void Read::cancel_slot()
{
   reject();
}
void Read::reply_slot()
{
   Mail *myMsgWin;
   myMsgWin=new Mail(pntMsg->getUin(),mainW,"msgedit");

   if (!myMsgWin->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete myMsgWin;
}
void Read::whois_slot()
{
   if (logged_on) send_uinSearch(pntMsg->getUin()); else loggedon();
}
void Read::next_slot()
{
   nextMsg();
   showMsg();
}
void Read::prev_slot()
{
   prevMsg();
   showMsg();
}



//#include "mail.moc"
