/**************************************************************************
* libXicq - Originally written by tnc (xtrophy@it.dk)                     *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* net.h                                                                   *
* network functions                                                       *
**************************************************************************/


#ifndef _NET_H
#define _NET_H

#include <sys/types.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include "config.h"
#include "structs.h"
#include "v2_codes.h"
#include "misc.h"
#include "ui2lib.h"

int  net_init(USER_CONFIGURATION *user_cfg);
int  net_udpGetSocket();
int  net_udpSend(unsigned char *mesg, int length);
int  net_udpRecv(unsigned char *mesg, int length);


#endif

