/**************************************************************************
* libXicq - Originally written by tnc (xtrophy@it.dk)                     *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* ui2lib.h                                                                *
* Functions the UI will call to send packages                             *
**************************************************************************/


#ifndef _UI2LIB_H_
#define _UI2LIB_H_


#include "net.h"
#include "packets.h"
#include "structs.h"


void send_login();
void send_login_1();
void send_ack(int sequence);
void send_msgAck(int sequence);
void send_keepAlive();
void send_contactList();
void send_message(unsigned long int receiver, char *message);
void send_url(unsigned long int receiver, char *url, char *desc);
void send_statusChange(unsigned long int status);
void send_uinSearch(unsigned long int uin);
void send_logout();

char *returnMyStatus();
long int status_str2num(char *str);


#endif