/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* main.h                                                                  *
* Handles communication with libXicq                                      *
**************************************************************************/


#ifndef _MAIN_H
#define _MAIN_H


#include <stdio.h>
#include <sys/time.h>
#include <ctype.h>
#include <libXicq.h>
#include "callbacks.h"
#include "cmd_parse.h"
#include "structs.h"
#include "io.h"

extern int logged_in;
extern int loginTry;

extern void my_exit(int val);

// We use min and max here and there in the code, 
// If we are using glibc 2+ all we have to do is include <sys/param.h>, 
// But under libc5 we have to define our own... 
#if (defined __GLIBC__) && (__GLIBC__ >= 2)
#   include <sys/param.h>
#else // (defined __GLIBC__) && (__GLIBC__ >= 2)
    /* Macros for min/max.  */
#   define MIN(a,b) (((a)<(b))?(a):(b))
#   define MAX(a,b) (((a)>(b))?(a):(b))
#endif // (defined __GLIBC__) && (__GLIBC__ >= 2)

#endif
