/**************************************************************************
* libXicq - Originally written by tnc (xtrophy@it.dk)                     *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* contact.h                                                               *
* Handles the contact list                                                *
**************************************************************************/


#ifndef _CONTACT_H
#define _CONTACT_H

#ifdef __FreeBSD__
# include <sys/types.h>
#endif
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "config.h"
#include "structs.h"
#include "misc.h"


int     contact_init(char *contactPath);
int     contact_length();
CONTACT contact_returnItemNum(int num);
char   *contact_uin2nick(unsigned long int uin);
unsigned long int contact_nick2uin(char *nick);
CONTACT contact_returnContact(unsigned long int uin);
int     contact_updateContact(CONTACT update_contact);
char   *contact_status2str(long int status);


#endif


