/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* cmd_parse.h                                                             *
* Parse keyboard input                                                    *
**************************************************************************/


#ifndef _CMD_PARSE_H
#define _CMD_PARSE_H


#include <stdlib.h>
#include <string.h>
#include <libXicq.h>
#include "config.h"
#include "help.h"


extern int (*aux_input_handler)(char *input);
extern int cmd_help(char *input);
extern int cmd_parse(char *input);
extern int cmd_msg(char *input);
extern int msg_input_handler(char *msgTmp);
extern int cmd_url(char *input);
extern int url_input_handler(char *msgTmp);
extern int cmd_who(char *input);
extern int cmd_status(char *input);
extern int cmd_clear(char *input);
extern int cmd_search_uin(char *input);
extern int cmd_talk(char *input);
extern int talk_input_handler(char *msgTmp);

typedef struct {
    int uin;
    int messageLength;
    char message[BUFSIZE];
} MSG_STRUCT;

typedef struct {
    int uin;
    int urlLength;
    char url[BUFSIZE];
    int descLength;
    char desc[BUFSIZE];
} URL_STRUCT;


#endif // _CMD_PARSE_H
